diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TermMover.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TermMover.java
new file mode 100644
index 0000000000..248f95fd9c
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TermMover.java
@@ -0,0 +1,88 @@
+// $Id$
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.database.update;
+
+import java.sql.SQLException;
+import java.util.ArrayList;
+import java.util.List;
+import java.util.UUID;
+
+import org.apache.log4j.Logger;
+
+import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
+import eu.etaxonomy.cdm.database.ICdmDataSource;
+
+/**
+ * Moves terms from one vocabulary to another.
+ * TODO does not yet check all DefinedTermBase_XXX tables except for representations.
+ * TODO Does also not handle AUD tables
+ * TODO Does not handle orderindex
+ * 
+ * @author a.mueller
+ * @date 06.09.2013
+ *
+ */
+public class TermMover extends SchemaUpdaterStepBase<TermMover> implements ITermUpdaterStep{
+	private static final Logger logger = Logger.getLogger(TermMover.class);
+	
+	public static final TermMover NewInstance(String stepName, UUID newVocabulary, String uuidTerm){
+		List<String> terms = new ArrayList<String>();
+		terms.add(uuidTerm);
+		return new TermMover(stepName, newVocabulary, terms);	
+	}
+	
+
+	public static final TermMover NewInstance(String stepName, UUID newVocabulary, List<String> terms){
+		return new TermMover(stepName, newVocabulary, terms);	
+	}
+	
+	
+	private String uuidNewVocabulary ;
+	private List<String> termUuids = new ArrayList<String>();
+	
+
+	private TermMover(String stepName, UUID newVocabulary, List<String> terms) {
+		super(stepName);
+		this.uuidNewVocabulary = newVocabulary.toString();
+		this.termUuids = terms; 
+	}
+
+	@Override
+	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException{
+ 		//get new vocabulary id
+		String sql = " SELECT id FROM TermVocabulary WHERE uuid = '%s'";
+		Integer id = (Integer)datasource.getSingleValue(String.format(sql, this.uuidNewVocabulary));
+		if (id == null || id == 0){
+			String messageString = "New vocabulary ("+uuidNewVocabulary+") does not exist. Can't move terms";
+			monitor.warning(messageString);
+			logger.warn(messageString);
+			return null;
+		}
+		
+		//check if in use
+		for (String uuid : this.termUuids){
+			sql = " UPDATE DefinedTermBase SET vocabulary_id = %d WHERE uuid = '%s' ";
+			sql = String.format(sql, id, uuid);
+			datasource.executeUpdate(sql);
+		}
+		
+		return 0;
+	}
+
+
+
+	public TermMover addTermUuid(UUID uuid){
+		this.termUuids.add(uuid.toString());
+		return this;
+	}
+	
+
+
+}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TermUpdaterBase.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TermUpdaterBase.java
index a71cc3dc9a..37a5e48ec9 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TermUpdaterBase.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TermUpdaterBase.java
@@ -17,7 +17,7 @@ import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
 import eu.etaxonomy.cdm.database.ICdmDataSource;
-import eu.etaxonomy.cdm.model.common.CdmMetaData;
+import eu.etaxonomy.cdm.model.metadata.CdmMetaData;
 
 /**
  * @author a.mueller
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TreeIndexUpdater.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TreeIndexUpdater.java
new file mode 100644
index 0000000000..15045f1b86
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TreeIndexUpdater.java
@@ -0,0 +1,111 @@
+// $Id$
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.database.update;
+
+import org.apache.log4j.Logger;
+
+import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
+import eu.etaxonomy.cdm.database.ICdmDataSource;
+import eu.etaxonomy.cdm.model.common.ITreeNode;
+
+/**
+ * @author a.mueller
+ * @date 09.08.2013
+ *
+ */
+public class TreeIndexUpdater extends AuditedSchemaUpdaterStepBase<TreeIndexUpdater> implements ISchemaUpdaterStep {
+	private static final Logger logger = Logger.getLogger(TreeIndexUpdater.class);
+	
+	private String indexColumnName = "treeIndex";
+	private String treeIdColumnName;
+	private String parentIdColumnName = "parent_id";
+	
+	public static final TreeIndexUpdater NewInstance(String stepName, String tableName, String treeIdColumnName, boolean includeAudTable){
+		return new TreeIndexUpdater(stepName, tableName, treeIdColumnName, null, includeAudTable);
+	}
+
+	public static final TreeIndexUpdater NewInstance(String stepName, String tableName, String treeIdColumnName, String indexColumnName, boolean includeAudTable){
+		return new TreeIndexUpdater(stepName, tableName, treeIdColumnName, indexColumnName, includeAudTable);
+	}
+	
+	
+	protected TreeIndexUpdater(String stepName, String tableName, String treeIdColumnName, String indexColumnName, boolean includeAudTable) {
+		super(stepName);
+		this.tableName = tableName;
+		this.treeIdColumnName = treeIdColumnName;
+		this.indexColumnName = indexColumnName == null ? this.indexColumnName : indexColumnName;
+		this.includeAudTable = includeAudTable;
+	}
+
+	@Override
+	protected boolean invokeOnTable(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
+		try{
+			boolean result = true;			
+			
+	//		String charType = "CHAR";  //TODO may depend on database type
+			
+			//clean up nodes without classification  //this should not happen with correct "delete" implementation
+			String sql = String.format(" DELETE FROM %s WHERE %s IS NULL ", tableName, treeIdColumnName);
+			datasource.executeUpdate(sql);
+			
+			//... set all index entries to NULL
+			sql = String.format(" UPDATE %s SET %s = NULL", tableName, indexColumnName);
+			datasource.executeUpdate(sql);
+			
+			//start
+			String separator = ITreeNode.separator;
+			String treePrefix = ITreeNode.treePrefix;
+			sql = String.format(" UPDATE %s tn " +
+					" SET tn.%s = CONCAT('%s%s', tn.%s, '%s', tn.id, '%s') " +
+					" WHERE tn.%s IS NULL AND tn.%s IS NOT NULL ", 
+						tableName, 
+						indexColumnName, separator, treePrefix, treeIdColumnName, separator, separator, 
+						parentIdColumnName, treeIdColumnName);
+			datasource.executeUpdate(sql);
+			
+			//width search index creation
+			String sqlCount = String.format(" SELECT count(*) as n " +
+					" FROM %s child INNER JOIN %s parent ON child.%s = parent.id " +
+					" WHERE parent.%s IS NOT NULL AND child.%s IS NULL ",
+					tableName, tableName, parentIdColumnName, indexColumnName, indexColumnName);
+			
+			Long n;
+			do {
+			
+				sql = String.format(" UPDATE %s child INNER JOIN %s parent ON child.%s = parent.id " +
+						" SET child.%s = CONCAT( parent.%s, child.id, '%s') " +
+						" WHERE parent.%s IS NOT NULL AND child.%s IS NULL ", 
+							tableName, tableName, parentIdColumnName, 
+							indexColumnName, indexColumnName, separator,
+							indexColumnName, indexColumnName);
+				datasource.executeUpdate(sql);
+				
+				n = (Long)datasource.getSingleValue(sqlCount);
+			}	while (n > 0) ;
+			
+			sqlCount = String.format(" SELECT count(*) as n " +
+					" FROM %s " +
+					" WHERE %s IS NULL ", tableName, indexColumnName);
+			n = (Long)datasource.getSingleValue(sqlCount);
+			if (n > 0){
+				String message = "There are tree nodes with no tree index in %s. This indicates that there is a problem in the tree structure of 1 or more classifications.";
+				logger.error(String.format(message, tableName));
+			}
+			
+			return result;
+		}catch(Exception e){
+			monitor.warning(e.getMessage(), e);
+			logger.error(e.getMessage());
+			return false;
+		}
+	}
+
+
+}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/UniqueIndexDropper.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/UniqueIndexDropper.java
index 29f6812b7f..5832b81eac 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/UniqueIndexDropper.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/UniqueIndexDropper.java
@@ -22,12 +22,10 @@ import eu.etaxonomy.cdm.database.ICdmDataSource;
  * @date 16.09.2010
  *
  */
-public class UniqueIndexDropper extends SchemaUpdaterStepBase<UniqueIndexDropper> implements ISchemaUpdaterStep {
+public class UniqueIndexDropper extends AuditedSchemaUpdaterStepBase<UniqueIndexDropper> implements ISchemaUpdaterStep {
 	private static final Logger logger = Logger.getLogger(UniqueIndexDropper.class);
 	
-	private String tableName;
 	private String indexColumn;
-	private boolean includeAudTable;
 	
 	public static final UniqueIndexDropper NewInstance(String tableName, String indexColumn, boolean includeAudTable){
 		String stepName = "Drop index " + tableName + "-" + indexColumn;
@@ -42,32 +40,16 @@ public class UniqueIndexDropper extends SchemaUpdaterStepBase<UniqueIndexDropper
 		this.includeAudTable = includeAudTable;
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase#invoke(eu.etaxonomy.cdm.database.ICdmDataSource, eu.etaxonomy.cdm.common.IProgressMonitor)
-	 */
 	@Override
-	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
-		boolean result = true;
-		result &= dropIndex(tableName, datasource, monitor);
-		if (includeAudTable){
-			String aud = "_AUD";
-			result &= dropIndex(tableName + aud, datasource, monitor);
-		}
-		return (result == true )? 0 : null;
-	}
-
-	private boolean dropIndex(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
+	protected boolean invokeOnTable(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
 		try {
 			if (checkExists(datasource)){
 				String updateQuery = getUpdateQueryString(tableName, datasource, monitor);
 				datasource.executeUpdate(updateQuery);
 			}
 			return true;
-		} catch ( DatabaseTypeNotSupportedException e) {
-			e.printStackTrace();
-			return false;
-		} catch ( SQLException e) {
-			e.printStackTrace();
+		} catch ( Exception e) {
+			monitor.warning(e.getMessage(), e);
 			return false;
 		}
 	}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/UpdaterBase.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/UpdaterBase.java
index 34d11339fa..e7849e2ee9 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/UpdaterBase.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/UpdaterBase.java
@@ -16,16 +16,16 @@ import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
 import eu.etaxonomy.cdm.database.ICdmDataSource;
-import eu.etaxonomy.cdm.model.common.CdmMetaData;
+import eu.etaxonomy.cdm.model.metadata.CdmMetaData;
 
 
 /**
+ * Common updater base class for updating schema or terms.
  * @author a.mueller
  * @date 16.11.2010
  *
  */
 public abstract class UpdaterBase<T extends ISchemaUpdaterStep, U extends IUpdater<U>> implements IUpdater<U> {
-	@SuppressWarnings("unused")
 	private static final Logger logger = Logger.getLogger(TermUpdaterBase.class);
 	
 	protected List<T> list;
@@ -55,23 +55,24 @@ public abstract class UpdaterBase<T extends ISchemaUpdaterStep, U extends IUpdat
 	
 	private boolean isToBeInvoked(ICdmDataSource datasource, IProgressMonitor monitor) {
 		boolean result = true;
-		String datasourceSchemaVersion;
+		String datasourceVersion;
 		try {
-			datasourceSchemaVersion = getCurrentVersion(datasource, monitor);
+			datasourceVersion = getCurrentVersion(datasource, monitor);
 		} catch (SQLException e1) {
 			monitor.warning("SQLException", e1);
 			return false;
 		}
 		
-		boolean isAfterMyStartVersion = isAfterMyStartVersion(datasourceSchemaVersion, monitor);
-		boolean isBeforeMyStartVersion = isBeforeMyStartVersion(datasourceSchemaVersion, monitor);
+		boolean isAfterMyStartVersion = isAfterMyStartVersion(datasourceVersion, monitor);
+		boolean isBeforeMyStartVersion = isBeforeMyStartVersion(datasourceVersion, monitor);
 //		boolean isBeforeMyTargetVersion = isBeforeMyTargetVersion(targetVersion, monitor);
-		boolean isDatasourceBeforeMyTargetVersion = isBeforeMyTargetVersion(datasourceSchemaVersion, monitor);
+		boolean isBeforeMyTargetVersion = isBeforeMyTargetVersion(targetVersion, monitor);
+		boolean isDatasourceBeforeMyTargetVersion = isBeforeMyTargetVersion(datasourceVersion, monitor);
 		
 		result &= isDatasourceBeforeMyTargetVersion;
-		result &= !(isAfterMyStartVersion /*&& isBeforeMyTargetVersion*/);
+		result &= !(isAfterMyStartVersion && isBeforeMyTargetVersion);
 		result &= ! (isBeforeMyStartVersion && getPreviousUpdater() == null);
-//		result &= !isBeforeMyTargetVersion;
+		result &= !isBeforeMyTargetVersion;
 		return result;
 	}
 	
@@ -88,20 +89,20 @@ public abstract class UpdaterBase<T extends ISchemaUpdaterStep, U extends IUpdat
 	@Override
 	public boolean invoke(String targetVersion, ICdmDataSource datasource, IProgressMonitor monitor) throws Exception{
 		boolean result = true;
-		String datasourceSchemaVersion;
+		String datasourceVersion;
 		try {
-			datasourceSchemaVersion = getCurrentVersion(datasource, monitor);
+			datasourceVersion = getCurrentVersion(datasource, monitor);
 		} catch (SQLException e1) {
 			monitor.warning("SQLException", e1);
 			return false;
 		}		
 
 		
-		boolean isAfterMyStartVersion = isAfterMyStartVersion(datasourceSchemaVersion, monitor);
-		boolean isBeforeMyStartVersion = isBeforeMyStartVersion(datasourceSchemaVersion, monitor);
+		boolean isAfterMyStartVersion = isAfterMyStartVersion(datasourceVersion, monitor);
+		boolean isBeforeMyStartVersion = isBeforeMyStartVersion(datasourceVersion, monitor);
 //		boolean isAfterMyTargetVersion = isAfterMyTargetVersion(targetVersion, monitor);
 		boolean isBeforeMyTargetVersion = isBeforeMyTargetVersion(targetVersion, monitor);
-		boolean isDatasourceBeforeMyTargetVersion = isBeforeMyTargetVersion(datasourceSchemaVersion, monitor);
+		boolean isDatasourceBeforeMyTargetVersion = isBeforeMyTargetVersion(datasourceVersion, monitor);
 		
 		
 		
@@ -140,7 +141,7 @@ public abstract class UpdaterBase<T extends ISchemaUpdaterStep, U extends IUpdat
 		if (result == false){
 			return result;
 		}
-		datasource.startTransaction();
+//		datasource.startTransaction();  transaction already started by CdmUpdater
 		try {
 			for (T step : list){
 				result &= handleSingleStep(datasource, monitor, result, step, false);
@@ -148,8 +149,6 @@ public abstract class UpdaterBase<T extends ISchemaUpdaterStep, U extends IUpdat
 					break;
 				}
 			}
-			// TODO schema version gets updated even if something went utterly wrong while executing the steps
-			// I don't think we want this to happen
 			if (result == true){
 				result &= updateVersion(datasource, monitor);
 			}else{
@@ -157,14 +156,10 @@ public abstract class UpdaterBase<T extends ISchemaUpdaterStep, U extends IUpdat
 			}
 			
 		} catch (Exception e) {
+			datasource.rollback();
 			logger.error("Error occurred while trying to run updater: " + this.getClass().getName());
 			result = false;
 		}
-		if (result == false){
-			datasource.commitTransaction();
-		}else{
-			datasource.rollback();
-		}
 		return result;
 	
 	}
@@ -184,7 +179,7 @@ public abstract class UpdaterBase<T extends ISchemaUpdaterStep, U extends IUpdat
 				monitor.worked(1);
 //			}
 		} catch (Exception e) {
-			monitor.warning("Monitor: Exception occurred while updating schema", e);
+			monitor.warning("Monitor: Exception occurred while handling single schema updating step", e);
 			datasource.rollback();
 			result = false;
 		}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/VocabularyCreator.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/VocabularyCreator.java
index 61de863295..cec6f6aec9 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/VocabularyCreator.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/VocabularyCreator.java
@@ -19,21 +19,22 @@ import org.apache.log4j.Logger;
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
 import eu.etaxonomy.cdm.database.ICdmDataSource;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.TermType;
 
 /**
  * @author a.mueller
  * @date 10.09.2010
  *
  */
-public class VocabularyCreator extends SchemaUpdaterStepBase implements ITermUpdaterStep{
+public class VocabularyCreator extends SchemaUpdaterStepBase<VocabularyCreator> implements ITermUpdaterStep{
 	@SuppressWarnings("unused")
 	private static final Logger logger = Logger.getLogger(VocabularyCreator.class);
 
 // **************************** STATIC METHODS ********************************/
 
-	public static final VocabularyCreator NewVocabularyInstance(UUID uuidVocabulary, String description,  String label, String abbrev, boolean isOrdered, Class termclass){
+	public static final VocabularyCreator NewVocabularyInstance(UUID uuidVocabulary, String description,  String label, String abbrev, boolean isOrdered, Class<?> termclass, TermType termType){
 		String stepName = makeStepName(label);
-		return new VocabularyCreator(stepName, uuidVocabulary, description, label, abbrev, isOrdered, termclass);	
+		return new VocabularyCreator(stepName, uuidVocabulary, description, label, abbrev, isOrdered, termclass, termType);	
 	}
 
 // *************************** VARIABLES *****************************************/
@@ -42,11 +43,12 @@ public class VocabularyCreator extends SchemaUpdaterStepBase implements ITermUpd
 	private String label;
 	private String abbrev;
 	private boolean isOrdered;
-	private Class termClass;
+	private Class<?> termClass;
+	private TermType termType;
 
 // ***************************** CONSTRUCTOR ***************************************/
 	
-	private VocabularyCreator(String stepName, UUID uuidVocabulary, String description, String label, String abbrev, boolean isOrdered, Class termClass) {
+	private VocabularyCreator(String stepName, UUID uuidVocabulary, String description, String label, String abbrev, boolean isOrdered, Class<?> termClass, TermType termType) {
 		super(stepName);
 		this.uuidVocabulary = uuidVocabulary;
 		this.description = description;
@@ -54,6 +56,7 @@ public class VocabularyCreator extends SchemaUpdaterStepBase implements ITermUpd
 		this.label = label;
 		this.isOrdered = isOrdered;
 		this.termClass = termClass;
+		this.termType = termType;
 	}
 
 // ******************************* METHODS *************************************************/
@@ -83,8 +86,7 @@ public class VocabularyCreator extends SchemaUpdaterStepBase implements ITermUpd
 		
 		
 		String id = Integer.toString(vocId);
-		//FIXME get current time
-		String created = "2010-09-16 10:15:00";
+		String created  = getNowString();
 		String dtype;
 		if (isOrdered){
 			dtype = "OrderedTermVocabulary";
@@ -94,8 +96,8 @@ public class VocabularyCreator extends SchemaUpdaterStepBase implements ITermUpd
 		String titleCache = (StringUtils.isNotBlank(label))? label : ( (StringUtils.isNotBlank(abbrev))? abbrev : description );  
 		String protectedTitleCache = getBoolean(false, datasource);
 		String termSourceUri = termClass.getCanonicalName();
-		String sqlInsertTerm = " INSERT INTO TermVocabulary (DTYPE, id, uuid, created, protectedtitlecache, titleCache, termsourceuri)" +
-				"VALUES ('" + dtype + "', " + id + ", '" + uuidVocabulary + "', '" + created + "', " + protectedTitleCache + ", '" + titleCache + "', '" + termSourceUri + "'" + ")"; 
+		String sqlInsertTerm = " INSERT INTO TermVocabulary (DTYPE, id, uuid, created, protectedtitlecache, titleCache, termsourceuri, termType)" +
+				"VALUES ('" + dtype + "', " + id + ", '" + uuidVocabulary + "', '" + created + "', " + protectedTitleCache + ", '" + titleCache + "', '" + termSourceUri + "', '" + termType.getKey() + "')"; 
 		datasource.executeUpdate(sqlInsertTerm);
 		
 		//language id
@@ -124,8 +126,8 @@ public class VocabularyCreator extends SchemaUpdaterStepBase implements ITermUpd
 		}
 		
 		UUID uuidRepresentation = UUID.randomUUID();
-		String sqlInsertRepresentation = " INSERT INTO Representation (id, created, uuid, text, abbreviatedlabel, label, language_id) " +
-				"VALUES (" + repId + ", '" + created + "', '" + uuidRepresentation + "', '" + description +  "', '" + label +  "',  '" + abbrev +  "', " + langId + ")"; 
+		String sqlInsertRepresentation = " INSERT INTO Representation (id, created, uuid, text, label, abbreviatedlabel, language_id) " +
+				"VALUES (" + repId + ", '" + created + "', '" + uuidRepresentation + "', '" + description +  "', '" + label +  "'," + nullSafeString(abbrev) +  ", " + langId + ")"; 
 		
 		datasource.executeUpdate(sqlInsertRepresentation);
 		
@@ -140,6 +142,14 @@ public class VocabularyCreator extends SchemaUpdaterStepBase implements ITermUpd
 
 
 
+	private String nullSafeString(String abbrev) {
+		if (abbrev == null){
+			return "NULL";
+		}else{
+			return "'" + abbrev + "'";
+		}
+	}
+
 	private static String makeStepName(String label) {
 		String stepName = "Create new vocabulary '"+ label + "'";
 		return stepName;
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v24_25/SchemaUpdater_24_25.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v24_25/SchemaUpdater_24_25.java
index d2c99e2cc1..8da12b0375 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v24_25/SchemaUpdater_24_25.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v24_25/SchemaUpdater_24_25.java
@@ -18,6 +18,7 @@ import eu.etaxonomy.cdm.database.update.ColumnAdder;
 import eu.etaxonomy.cdm.database.update.ISchemaUpdater;
 import eu.etaxonomy.cdm.database.update.ISchemaUpdaterStep;
 import eu.etaxonomy.cdm.database.update.SchemaUpdaterBase;
+import eu.etaxonomy.cdm.database.update.SortIndexUpdater;
 import eu.etaxonomy.cdm.database.update.v25_30.SchemaUpdater_25_30;
 
 /**
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v24_25/TermUpdater_24_25.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v24_25/TermUpdater_24_25.java
index 0a21d70def..bbb8a88491 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v24_25/TermUpdater_24_25.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v24_25/TermUpdater_24_25.java
@@ -21,6 +21,7 @@ import eu.etaxonomy.cdm.database.update.SingleTermUpdater;
 import eu.etaxonomy.cdm.database.update.TermUpdaterBase;
 import eu.etaxonomy.cdm.database.update.v25_30.TermUpdater_25_30;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.name.NomenclaturalStatusType;
 
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/FeatureNodeTreeColumnUpdater.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/FeatureNodeTreeColumnUpdater.java
index eecd61aa8f..32d36c1b4f 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/FeatureNodeTreeColumnUpdater.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/FeatureNodeTreeColumnUpdater.java
@@ -24,7 +24,7 @@ import eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase;
  * @date 16.09.2010
  *
  */
-public class FeatureNodeTreeColumnUpdater extends SchemaUpdaterStepBase implements ISchemaUpdaterStep {
+public class FeatureNodeTreeColumnUpdater extends SchemaUpdaterStepBase<FeatureNodeTreeColumnUpdater> implements ISchemaUpdaterStep {
 	@SuppressWarnings("unused")
 	private static final Logger logger = Logger.getLogger(FeatureNodeTreeColumnUpdater.class);
 	
@@ -43,9 +43,6 @@ public class FeatureNodeTreeColumnUpdater extends SchemaUpdaterStepBase implemen
 		this.includeAudTable = includeAudTable;
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase#invoke(eu.etaxonomy.cdm.database.ICdmDataSource, eu.etaxonomy.cdm.common.IProgressMonitor)
-	 */
 	@Override
 	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
 		boolean result = true;
@@ -58,38 +55,43 @@ public class FeatureNodeTreeColumnUpdater extends SchemaUpdaterStepBase implemen
 	}
 
 	private boolean updateTree(String treeTableName, String nodeTableName, ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
-		String resulsetQuery = "SELECT id, root_id FROM @treeTableName ORDER BY id";
-		resulsetQuery = resulsetQuery.replace("@treeTableName", treeTableName);
-
-		ResultSet rs = datasource.executeQuery(resulsetQuery);
-		while (rs.next()){
-			Integer treeId = rs.getInt("id");
-			Integer rootId = rs.getInt("root_id");
-			String updateQuery = "UPDATE @nodeTableName SET featuretree_id = @treeId WHERE id = @rootId";
-			updateQuery = updateQuery.replace("@nodeTableName", nodeTableName);
-			updateQuery = updateQuery.replace("@treeId", treeId.toString());
-			updateQuery = updateQuery.replace("@rootId", rootId.toString());
-			datasource.executeUpdate(updateQuery);
-		}	
-		
-		String countQuery = "SELECT count(*) FROM @nodeTableName WHERE featuretree_id IS NULL";
-		countQuery = countQuery.replace("@nodeTableName", nodeTableName);
-		Long countMissingTrees = (Long)datasource.getSingleValue(countQuery);
-		while (countMissingTrees > 0){
-			String updateQuery = "UPDATE @nodeTableName AS child INNER JOIN @nodeTableName AS parent ON child.parent_fk = parent.id " +
-					"SET child.featuretree_id = parent.featuretree_id WHERE child.featuretree_id IS NULL";
-			updateQuery = updateQuery.replace("@nodeTableName", nodeTableName);
-//			updateQuery = updateQuery.replace("@treeId", treeId.toString());
-				
-			datasource.executeUpdate(updateQuery);
-			Long oldCountMissingTrees = countMissingTrees;
-			countMissingTrees = (Long)datasource.getSingleValue(countQuery);
-			if (oldCountMissingTrees.equals(countMissingTrees)){
-				throw new RuntimeException("No row updated in FeatureNodeTreeColumnUpdater. Throw exception to avoid infinite loop");
+		try{
+			String resulsetQuery = "SELECT id, root_id FROM @treeTableName ORDER BY id";
+			resulsetQuery = resulsetQuery.replace("@treeTableName", treeTableName);
+	
+			ResultSet rs = datasource.executeQuery(resulsetQuery);
+			while (rs.next()){
+				Integer treeId = rs.getInt("id");
+				Integer rootId = rs.getInt("root_id");
+				String updateQuery = "UPDATE @nodeTableName SET featuretree_id = @treeId WHERE id = @rootId";
+				updateQuery = updateQuery.replace("@nodeTableName", nodeTableName);
+				updateQuery = updateQuery.replace("@treeId", treeId.toString());
+				updateQuery = updateQuery.replace("@rootId", rootId.toString());
+				datasource.executeUpdate(updateQuery);
+			}	
+			
+			String countQuery = "SELECT count(*) FROM @nodeTableName WHERE featuretree_id IS NULL";
+			countQuery = countQuery.replace("@nodeTableName", nodeTableName);
+			Long countMissingTrees = (Long)datasource.getSingleValue(countQuery);
+			while (countMissingTrees > 0){
+				String updateQuery = "UPDATE @nodeTableName AS child INNER JOIN @nodeTableName AS parent ON child.parent_fk = parent.id " +
+						"SET child.featuretree_id = parent.featuretree_id WHERE child.featuretree_id IS NULL";
+				updateQuery = updateQuery.replace("@nodeTableName", nodeTableName);
+	//			updateQuery = updateQuery.replace("@treeId", treeId.toString());
+					
+				datasource.executeUpdate(updateQuery);
+				Long oldCountMissingTrees = countMissingTrees;
+				countMissingTrees = (Long)datasource.getSingleValue(countQuery);
+				if (oldCountMissingTrees.equals(countMissingTrees)){
+					throw new RuntimeException("No row updated in FeatureNodeTreeColumnUpdater. Throw exception to avoid infinite loop");
+				}
 			}
+			return true;
+		}catch(Exception e){
+			monitor.warning(e.getMessage(), e);
+			logger.error(e.getMessage());
+			return false;
 		}
-		
-		return true;
 	}
 
 }
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/PolytomousKeyDataMover.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/PolytomousKeyDataMover.java
index 087b2e5ffe..972d5a1ab4 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/PolytomousKeyDataMover.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v25_30/PolytomousKeyDataMover.java
@@ -47,18 +47,22 @@ public class PolytomousKeyDataMover extends SchemaUpdaterStepBase implements ISc
 		this.includeAudTable = includeAudTable;
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase#invoke(eu.etaxonomy.cdm.database.ICdmDataSource, eu.etaxonomy.cdm.common.IProgressMonitor)
-	 */
+
 	@Override
 	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
-		boolean result = true;
-		result &= movePolytomousKeys(featureTreeTableName, featureNodeTableName, polytomousKeyTableName, polytomousKeyNodeTableName, datasource, monitor, false);
-		if (includeAudTable){
-			String aud = "_AUD";
-			result &= movePolytomousKeys(featureTreeTableName + aud, featureNodeTableName + aud, polytomousKeyTableName + aud, polytomousKeyNodeTableName + aud, datasource, monitor, true);
+		try {
+			boolean result = true;
+			result &= movePolytomousKeys(featureTreeTableName, featureNodeTableName, polytomousKeyTableName, polytomousKeyNodeTableName, datasource, monitor, false);
+			if (includeAudTable){
+				String aud = "_AUD";
+				result &= movePolytomousKeys(featureTreeTableName + aud, featureNodeTableName + aud, polytomousKeyTableName + aud, polytomousKeyNodeTableName + aud, datasource, monitor, true);
+			}
+			return (result == true )? 0 : null;
+		} catch (Exception e) {
+			monitor.warning(e.getMessage(), e);
+			logger.error(e.getMessage());
+			return null;
 		}
-		return (result == true )? 0 : null;
 	}
 
 	private boolean movePolytomousKeys(String featureTreeTableName, String featureNodeTableName, String polytomousKeyTableName, String polytomousKeyNodeTableName, ICdmDataSource datasource, IProgressMonitor monitor, boolean isAudit) throws SQLException {
@@ -70,7 +74,7 @@ public class PolytomousKeyDataMover extends SchemaUpdaterStepBase implements ISc
 		result &= moveQuestions(featureNodeTableName, polytomousKeyNodeTableName, datasource, isAudit);
 		
 		result &= deleteOldData(datasource, isAudit);
-		return true;
+		return result;
 	}
 
 
